﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KOP_Labs
{
    public partial class CustomComboBox : UserControl
    {
        public CustomComboBox()
        {
            InitializeComponent();
        }
        private string examp = "Введите текст от " + decimal.MinValue + " до" + decimal.MaxValue + " символов";
        public string Error { get; protected set; } = string.Empty;
        public decimal? MinValue { get; set; }
        public decimal? MaxValue { get; set; }

        private EventHandler _changeEvent;
        public event EventHandler ChangeEvent
        {
            add
            {
                _changeEvent += value;
            }
            remove
            {
                _changeEvent -= value;
            }

        }
        private void textBox_TextChanged(object sender, EventArgs e)
        {
            _changeEvent?.Invoke(sender, e);
        }

        private void textBox_Enter(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.Show(examp, textBox, 30, -20, 2000);
        }

        public string? TextBoxValue
        {
            get
            {
                if (MinValue == null || MaxValue == null)
                {
                    Error = "Диапазон не задан";
                    return null;
                }
                if (textBox.Text.Length >= MinValue && textBox.Text.Length <= MaxValue)
                {
                    return textBox.Text;
                }
                Error = "Ваш текст" + " лежит \n вне диапозона" + MinValue + " - " + MaxValue;
                return null;
            }
            set
            {
                if (MinValue == null || MaxValue == null)
                {
                    Error = "Диапазон не задан";
                }
                if (value.Length >= MinValue && value.Length <= MaxValue)
                {
                    textBox.Text = value;
                }
            }
        }

    }
}
