﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KOP_Labs
{
    public partial class CustomListBox : UserControl
    {
        public CustomListBox()
        {
            InitializeComponent();
        }
        private EventHandler _changeEvent;

        private void checkedListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            _changeEvent?.Invoke(sender, e);
        }

        public event EventHandler ChangeEvent
        {
            add
            {
                _changeEvent += value;
            }
            remove
            {
                _changeEvent -= value;
            }

        }
        public void Clear()
        {
            checkedListBox.Items.Clear();
        }
        public void AddToList(string Value)
        {
            if (Value == null) 
            {
                return;
            }
            checkedListBox.Items.Add(Value);
        }
        public string SelectedElement
        {
            get
            {
                return (checkedListBox.SelectedIndex > -1 && checkedListBox.GetItemChecked(checkedListBox.SelectedIndex)) ? checkedListBox.SelectedItem.ToString() : string.Empty;
            }
            set 
            {
                if (checkedListBox.Items.Contains(value)) {
                    checkedListBox.SelectedItem = value;
                }
            }
        }
    }
}
